import React$1 from 'react';

type PhonenumberChangeEventHandle = (v: string, options: {
    formated: string;
    fullValue: string;
    valid: boolean;
}) => void;
type PhoneNumberInputWrapperProps = {
    className?: string;
    style?: React.CSSProperties;
    children: React.ReactNode;
    isInValid?: boolean;
};
type ReactPhonenumberInputProps = {
    countries?: CountryCode[] | readonly CountryCode[];
    defaultCountry?: CountryCode;
    className?: string;
    style?: React.CSSProperties;
    value?: string;
    showCallingCode?: boolean;
    placeholder?: string;
    onChange?: PhonenumberChangeEventHandle;
    onCountryCodeChange?: (c: CountryCode) => void;
    inputClassName?: string;
    inputStyle?: React.CSSProperties;
    selectClassName?: string;
    selectStyle?: React.CSSProperties;
    optionClassName?: string;
    optionStyle?: React.CSSProperties;
};
type PhoneNumberCallingCodeProps = {
    callingCode: string;
};
type PhoneNumberInputElementProps = {
    value: string;
    placeholder?: string;
    onChange: (value: string) => void;
    className?: string;
    style?: React.CSSProperties;
};
type PhoneNumberSelectProps = {
    countries: CountryCode[] | readonly CountryCode[];
    countryCode: CountryCode;
    setCountryCode: (c: CountryCode) => void;
    onCountryCodeChange?: (c: CountryCode) => void;
    className?: string;
    style?: React.CSSProperties;
    optionClassName?: string;
    optionStyle?: React.CSSProperties;
};
type PhoneNumberOptionProps = {
    countryCode: CountryCode;
    className?: string;
    style?: React.CSSProperties;
};
type BasePhoneNumberInputProps = ReactPhonenumberInputProps & {
    SelectComponent: React.ComponentType<PhoneNumberSelectProps>;
    CallingCodeComponent: React.ComponentType<PhoneNumberCallingCodeProps>;
    InputComponent: React.ComponentType<PhoneNumberInputElementProps>;
    WrapperComponent: React.ComponentType<PhoneNumberInputWrapperProps>;
};
type CountryCode = 'AC' | 'AD' | 'AE' | 'AF' | 'AG' | 'AI' | 'AL' | 'AM' | 'AO' | 'AR' | 'AS' | 'AT' | 'AU' | 'AW' | 'AX' | 'AZ' | 'BA' | 'BB' | 'BD' | 'BE' | 'BF' | 'BG' | 'BH' | 'BI' | 'BJ' | 'BL' | 'BM' | 'BN' | 'BO' | 'BQ' | 'BR' | 'BS' | 'BT' | 'BW' | 'BY' | 'BZ' | 'CA' | 'CC' | 'CD' | 'CF' | 'CG' | 'CH' | 'CI' | 'CK' | 'CL' | 'CM' | 'CN' | 'CO' | 'CR' | 'CU' | 'CV' | 'CW' | 'CX' | 'CY' | 'CZ' | 'DE' | 'DJ' | 'DK' | 'DM' | 'DO' | 'DZ' | 'EC' | 'EE' | 'EG' | 'EH' | 'ER' | 'ES' | 'ET' | 'FI' | 'FJ' | 'FK' | 'FM' | 'FO' | 'FR' | 'GA' | 'GB' | 'GD' | 'GE' | 'GF' | 'GG' | 'GH' | 'GI' | 'GL' | 'GM' | 'GN' | 'GP' | 'GQ' | 'GR' | 'GT' | 'GU' | 'GW' | 'GY' | 'HK' | 'HN' | 'HR' | 'HT' | 'HU' | 'ID' | 'IE' | 'IL' | 'IM' | 'IN' | 'IO' | 'IQ' | 'IR' | 'IS' | 'IT' | 'JE' | 'JM' | 'JO' | 'JP' | 'KE' | 'KG' | 'KH' | 'KI' | 'KM' | 'KN' | 'KP' | 'KR' | 'KW' | 'KY' | 'KZ' | 'LA' | 'LB' | 'LC' | 'LI' | 'LK' | 'LR' | 'LS' | 'LT' | 'LU' | 'LV' | 'LY' | 'MA' | 'MC' | 'MD' | 'ME' | 'MF' | 'MG' | 'MH' | 'MK' | 'ML' | 'MM' | 'MN' | 'MO' | 'MP' | 'MQ' | 'MR' | 'MS' | 'MT' | 'MU' | 'MV' | 'MW' | 'MX' | 'MY' | 'MZ' | 'NA' | 'NC' | 'NE' | 'NF' | 'NG' | 'NI' | 'NL' | 'NO' | 'NP' | 'NR' | 'NU' | 'NZ' | 'OM' | 'PA' | 'PE' | 'PF' | 'PG' | 'PH' | 'PK' | 'PL' | 'PM' | 'PR' | 'PS' | 'PT' | 'PW' | 'PY' | 'QA' | 'RE' | 'RO' | 'RS' | 'RU' | 'RW' | 'SA' | 'SB' | 'SC' | 'SD' | 'SE' | 'SG' | 'SH' | 'SI' | 'SJ' | 'SK' | 'SL' | 'SM' | 'SN' | 'SO' | 'SR' | 'SS' | 'ST' | 'SV' | 'SX' | 'SY' | 'SZ' | 'TA' | 'TC' | 'TD' | 'TG' | 'TH' | 'TJ' | 'TK' | 'TL' | 'TM' | 'TN' | 'TO' | 'TR' | 'TT' | 'TV' | 'TW' | 'TZ' | 'UA' | 'UG' | 'US' | 'UY' | 'UZ' | 'VA' | 'VC' | 'VE' | 'VG' | 'VI' | 'VN' | 'VU' | 'WF' | 'WS' | 'XK' | 'YE' | 'YT' | 'ZA' | 'ZM' | 'ZW';
declare const allCountries: readonly CountryCode[];

declare const PhoneNumberInputWithNativeSelect: React$1.FC<ReactPhonenumberInputProps>;

declare const PhonenumberInput: React$1.FC<ReactPhonenumberInputProps>;

declare const SearchSelect: React$1.ComponentType<PhoneNumberSelectProps & {
    border?: boolean;
}>;

declare const BaseReactPhonenumberInput: React$1.FC<BasePhoneNumberInputProps>;

declare function getCountryCallingCode(country: CountryCode): string;

declare const formatChinesePhoneNumber: (phoneNumber: string) => string;
declare const formatHongKongPhoneNumber: (phoneNumber: string) => string;

declare const validateChinesePhoneNumber: (phoneNumber: string) => boolean;
declare const validateHongKongPhoneNumber: (phoneNumber: string) => boolean;

export { BasePhoneNumberInputProps, BaseReactPhonenumberInput, CountryCode, PhoneNumberCallingCodeProps, PhoneNumberInputElementProps, PhoneNumberInputWithNativeSelect, PhoneNumberInputWrapperProps, PhoneNumberOptionProps, PhoneNumberSelectProps, PhonenumberChangeEventHandle, ReactPhonenumberInputProps, SearchSelect, allCountries, PhonenumberInput as default, formatChinesePhoneNumber, formatHongKongPhoneNumber, getCountryCallingCode, validateChinesePhoneNumber, validateHongKongPhoneNumber };
